`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/05/12 00:33:50
// Design Name: 
// Module Name: fsm
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`include "global.vh"

module fsm(
    instruction,
    valid,
    curr_state,
    rst,
    decoded_input
);
    output reg [2:0] curr_state;
    output reg [1:0] instruction;
    input rst, valid;
    input [3:0] decoded_input;

    reg [1:0] next_instruction;
    reg [2:0] next_state;

    always @*
        case (curr_state)
            `DIGIT_3_STATE:
                if (decoded_input == 4'd0 || decoded_input == 4'd1 || 
                    decoded_input == 4'd2 || decoded_input == 4'd3 || 
                    decoded_input == 4'd4 || decoded_input == 4'd5 || 
                    decoded_input == 4'd6 || decoded_input == 4'd7 || 
                    decoded_input == 4'd8 || decoded_input == 4'd9)
                    begin
                        next_state = `DIGIT_2_STATE;
                        next_instruction = instruction;
                    end
                else
                    begin
                        next_state = `DIGIT_3_STATE;
                        next_instruction = instruction;
                    end
           `DIGIT_2_STATE:
                case (decoded_input)
                    `key_add_pos:
                        begin
                            next_state = `DIGIT_1_STATE;
                            next_instruction = 2'd0;
                        end
                    `key_subtract_pos:
                        begin
                            next_state = `DIGIT_1_STATE;
                            next_instruction = 2'd1;
                        end
                    `key_multiply_pos:
                        begin
                            next_state = `DIGIT_1_STATE;
                            next_instruction = 2'd2;
                        end 
                    default:
                        begin
                            next_state = `DIGIT_2_STATE;
                            next_instruction = instruction;
                        end 
                endcase
            `DIGIT_1_STATE:
                if (decoded_input == 4'd0 || decoded_input == 4'd1 || 
                    decoded_input == 4'd2 || decoded_input == 4'd3 || 
                    decoded_input == 4'd4 || decoded_input == 4'd5 || 
                    decoded_input == 4'd6 || decoded_input == 4'd7 || 
                    decoded_input == 4'd8 || decoded_input == 4'd9)
                    begin
                        next_state = `DIGIT_0_STATE;
                        next_instruction = instruction;
                    end
                else
                    begin
                        next_state = `DIGIT_1_STATE;
                        next_instruction = instruction;
                    end
            `DIGIT_0_STATE:
                if (decoded_input == `key_enter_pos)
                    begin
                        next_state = `FINAL_DISPLAY_STATE;
                        next_instruction = instruction;
                    end
                else
                    begin
                        next_state = `DIGIT_0_STATE;
                        next_instruction = instruction;
                    end
            `FINAL_DISPLAY_STATE:
                if (decoded_input == `key_enter_pos)
                    begin
                        next_state = `DIGIT_3_STATE;
                        next_instruction = instruction;
                    end
                else
                    begin
                        next_state = `FINAL_DISPLAY_STATE;
                        next_instruction = instruction;
                    end
            default:
                    begin
                        next_state = `DIGIT_3_STATE;
                        next_instruction = instruction;
                    end
        endcase
    
    always @(posedge valid or posedge rst)
        if (rst)
            begin
            curr_state <= 3'd0; 
            instruction <= 2'd0;
            end
        else
            begin
            curr_state <= next_state;
            instruction <= next_instruction;    
            end
endmodule
